;Erzeugt Sudokus
mn:
    lea sa6(PC),a0
    move.l (a0),a6 
    lea SUDOKULeicht1(PC),a0
    move.w #8,d0
    
mnerz:
    move.b (a0)+,d1
    move.w #8,d2
    sub.w d0,d2
    ext.w d2
    ext.l d2
    divu #3,d2
    lea SS2(PC),a2
    add.b #1,d2;?!?
    move.b d2,(a2)
    tst.b d1
;testet wo noch kein fertiges sudoku gespeichert wurde
;0=leer 1=sudoku vollstndig 2=sudoku mit lchern
    beq mnerz2
    cmp.b #1,d1
    beq fertig
    lea 81(a0),a0
    dbra d0,mnerz
    bsr Tastatur
    tst.w APD_FLAG
    bne trapvier
    bra mn
    
trapvier:
;Wenn der Sudoku-Speicher voll ist, schaltet
;sich der Rechner nach ein paar Minuten ohne
;Tastatureingabe aus.
    movem.l d0-d7/a0-a6,-(a7)
    trap #4
    movem.l (a7)+,d0-d7/a0-a6
    bsr reset_timer
    bra mn

;Erzeugt ein Sudoku ohne Leerfelder
mnerz2:
    move.l a0,-(a7)
    bsr loeschen
    add.l #4,a7
    move.l a0,a1

    move.w #60,d5
    move.w #80,d6
    
m1:

;Bei einer Eingabe wird die
;Erzeugung unterbrochen.
    bsr Tastatur


    move.w #9,d0
    bsr random
    add.b #1,d0
m2:   
    move.b d0,d3
    move.b d6,d2
    ext.w d2
    ext.l d2
    divu #9,d2
    move.l d2,d4
    swap d4
    ext.l d2
    ext.l d4
    bsr teste
    bsr reset_timer
    tst.b d7
    beq fehler
    move.w #60,d5
    move.l a1,a2
    ext.w d6
    ext.l d6
    add.l d6,a2
    move.b d3,(a2)

    dbra d6,m1
    bra fertig
fehler:
    dbra d5,m1
    bra mn





fertig:
    move.b #1,-1(a0)
    
fert2:

    move.l (handleadress3),a5
    movem.l d0-d7/a0-a6,-(a7)
    move.l #81,-(a7)
    move.l a0,-(a7)
    move.l a5,-(a7)
    jsr tios::memcpy
    lea 12(a7),a7
    movem.l (a7)+,d0-d7/a0-a6

            
    lea SS2(PC),a5
    move.b (a5),d5
    move.b d5,d6
    ext.w d5
    mulu #4,d5

    lea handleadress3(PC),a5
    move.l (a5),a5
    add.w #40,d5;40+1+4x Lcher;
    

;In das Sudoku werden nun Lcher gerissen.
f0:
    move.w #81,d0

    bsr Tastatur;siehe oben
    bsr random
    ext.w d0
    ext.l d0
    
    move.l a5,a2
    add.l d0,a2
    tst.b (a2)
    beq f0
    move.b #0,(a2)
    dbra d5,f0
    
    move.l (handleadress4),a1
    move.l (handleadress3),a5
    movem.l d0-d7/a0-a6,-(a7)
    move.l #81,-(a7)
    move.l a5,-(a7)
    move.l a1,-(a7)
    jsr tios::memcpy
    lea 12(a7),a7
    movem.l (a7)+,d0-d7/a0-a6
        
    move.b #81,d0
    
;Nun wird versucht das Sudoku zu lsen.
;Wird dies geschafft ist das Sudoku eindeutig.    

f0b:
    loesen d6,handleadress4(PC)
    bsr reset_timer
    pea handleadress4(PC)
    bsr Tester
    add.l #4,a7
    lea ungel(PC),a1
    cmp.b (a1),d0
    beq f0c
    move.b (a1),d0
    bra f0b
    
f0c:
    lea stat(PC),a1
    tst.b (a1)
    ;Der Lsungsvorgang war nicht erfogreich.
    bne fert2

    move.l (handleadress3),a1
    movem.l d0-d7/a0-a6,-(a7)
    move.l #81,-(a7)
    move.l a1,-(a7)
    move.l a0,-(a7)
    jsr tios::memcpy
    lea 12(a7),a7
    movem.l (a7)+,d0-d7/a0-a6
    move.b #2,-(a0)
    
    clr.l d0

    bsr jumper

    bra mn

reset_timer:
    move.l  APD_INIT,APD_TIMER
    clr.w   APD_FLAG
    rts
    
