
    xdef    _main
    xdef    _comment
    xdef	_ti92plus
    include "doorsos.h"
    include "util.h"
    

;-------------------------------------------------------------
; Program made with Fargo Program Editor v2.0
; Benoit SCHERRER - p.c.scherrer@wanadoo.fr
;
; (please, don't delete this small copyright text,
; or else copy it in your text file. My only dream
; is that Fargedit become famous)
;
;(Ich verwendete auch Assembly Studio 8x und Crimson Editor)
;-------------------------------------------------------------



;***************** Start of FARGO II Program ******************






loesen         MACRO
; Sudoku adresse
; Input: a1-Sudoku-Adresse  a2-Handle mit 81 words
; Output: a1-Sudoku Aufgelst
    movem.l d0-d1/a1-a2,-(a7)
    clr.b d0
    lea \2,a1
    move.l (a1),a1
    lea handleloeseadress(PC),a2
    move.l (a2),a2
    move.b \1,d1
    bsr loese
    movem.l (a7)+,a1-a2/d0-d1   
                ENDM
                
loesen2         MACRO
; Sudoku adresse
; Input: a1-Sudoku-Adresse  a2-Handle mit 81 words
; Output: a1-Sudoku Aufgelst
    movem.l d0-d1/a1-a2,-(a7)
    clr.b d0
    lea \2,a1   
    move.l (a1),a1
    lea handleloeseadress(PC),a2
    move.l (a2),a2
    move.b \1,d1
    move.b #1,(testflag)
    bsr loeseb
    movem.l (a7)+,a1-a2/d0-d1   
                ENDM
                
Schrift_gro    MACRO
    bsr sgro
                ENDM
                
Schrift_normal  MACRO
    bsr snormal
                ENDM
                
Schrift_klein   MACRO
    bsr sklein
                ENDM
Breakpoint      MACRO
;ruft Trap 9 auf, (Verwende ich zum Debuggen unter VTI)
    movem.l d0/a0,-(a7)
    move.l #1,d0
    trap #9
    movem.l (a7)+,d0/a0
                ENDM
bsum      MACRO
;gibt die Summe der 9 ersten Bits eines Words zurck
    move.l a5,-(a7)
    move.l summenadr(PC),a5
    move.l \1,-(a7)
    and.l #$000001FF,\1
    add.l \1,a5
    add.l \1,a5
    move.w (a5),\2
    move.l (a7)+,\1
    move.l (a7)+,a5
           ENDM
                
      
sgro:
;Stellt die Schrift auf gro um
    movem.l d0-d7/a0-a6,-(a7)
    move.w #2,-(a7)         
    jsr tios::FontSetSys    
    add.l #2,a7
    movem.l (a7)+,d0-d7/a0-a6
    rts
    
sklein:
;Stellt die Schrift auf klein um
    movem.l d0-d7/a0-a6,-(a7)
    move.w #0,-(a7)         
    jsr tios::FontSetSys    
    add.l #2,a7
    movem.l (a7)+,d0-d7/a0-a6
    rts

snormal:
;Stellt die Schrift auf normal um
    movem.l d0-d7/a0-a6,-(a7)
    move.w #1,-(a7)         
    jsr tios::FontSetSys    
    add.l #2,a7
    movem.l (a7)+,d0-d7/a0-a6
    rts
    
loeschen:
;lscht ein Sudoku (81Bytes) Eingabe
;ber Stapel: Adresse.l
    move.w #80,d7
    move.l 4(a7),a1

eins:
    move.b #0,(a1)+
    dbra d7,eins
    rts

teste:
;testet ob in einem Kstchen eine Zahl
;mglich ist.
;Eingabe:
;   d3.b = Zahl
;   d2.b = Reihe
;   d4.b = Zeile
;   a1.l = Sudoku-Adresse
;Ausgabe:
;   d7.b = 0 nicht mglich
;          1 mglich

    movem.l d0-d7/a2,-(a7)
    move.l a1,a2
    ext.w d2
    move.w d2,d6
    mulu.w #9,d6    ;teste Reihe (-xachse)     
    add.l d6,a2
    move.w #8,d5
    
t1:
    move.b (a2)+,d7
    cmp.b d7,d3
    beq fehle
    dbra d5,t1
    
    ext.w d4        ;teste Zeile (-yachse)
    ext.l d4
    move.l a1,a2
    add.l d4,a2
    move.w #8,d5
    
t2:
    move.b (a2),d6
    lea 9(a2),a2
    cmp.b d6,d3
    beq fehle
    dbra d5,t2
    
    ext.l d2        ;teste Feld
    divu #3,d2
    ext.l d2
    divu #3,d4
    ext.l d4
    move.w #2,d5
    
t3:
    move.w #2,d6
    
t4:
    move.l a1,a2
    move.b d2,d7
    ext.w d7
    ext.l d7
    mulu #3,d7
    add.b d5,d7
    mulu #3,d7
    add.b d4,d7
    mulu #3,d7
    add.b d6,d7
    add.l d7,a2
    move.b (a2),d7
    cmp.b d7,d3
    beq fehle
    dbra d6,t4
    dbra d5,t3
    
    movem.l (a7)+,d0-d7/a2
    move.b #1,d7
    rts
    
fehle:
    movem.l (a7)+,d0-d7/a2
    clr.b d7
    rts
    
ende:
;lscht letzte Tastatureingabe und beendet das Programm
    move.w   #0,(tios::kb_vars+$1c)
    rts

init_idling:
;initialisiert den idling prozess und
;fhrt in dann aus.
;gibt den Code der gedrckten Taste in
;d0.w zurck. Whrend des Wartens werden
;neue Sudokus erstellt (bsr mn).

    movem.l d1-d7/a0-a2/a4-a5,-(a7)
    move.l a7,(sa71)
    bsr mn
    move.l (a7)+,a3
    movem.l (a7)+,d1-d7/a0-a2/a4-a5

emn0:
    move.l a3,-(a6)
    tst.w d0
    bne etaste_wurde_gedrckt
idling:   
    move.l (a6)+,a3
    movem.l d1-d7/a0-a2/a4-a5,-(a7)
    jsr (a3)
    move.l (a7)+,a3
    movem.l (a7)+,d1-d7/a0-a2/a4-a5
    bra emn0

etaste_wurde_gedrckt: 
    rts

    
    
;    include brixen.sdb
    include "aufloeser.inc"
    include "tester.inc"
    include "tastatur.inc"
    include "texte.inc"
    include "protokoll.inc"
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++ M A I N ++++++++++++++++++++++++++++++++++++++++++++++++++

_main:
    include "sucher.inc"
    move.l summenadr(PC),a0
    add.l #1024,a0
    move.w #511,d0
mx1:
    clr.w -(a0)
    move.w #8,d1
mx2:
    ext.l d0
    ext.l d1
    btst.l d1,d0
    bne mx3
    add.w #1,(a0)
mx3:
    dbra d1,mx2
    dbra d0,mx1
        
    Schrift_gro
    bsr reset_timer

;Da zwischen zwei Prozessen (eigentl. Programm &
;Sudoku Erzeugung) stndig gesprungen wird, gibt
;es einen 2. Stapel (a6) fr die Sudoku Erzeugung.
    lea handlestackadress(PC),a6
    move.l (a6),a6

    lea sa6(PC),a0
    move.l a6,(a0)  
    
    
    
    lea SUDOKUIndex(PC),a0
    cmp.b #1,(a0)
    beq Sudoku_vorhanden
    
    bsr Eingabe
    lea SS(PC),a0
    cmp.b #4,(a0)
    bne LBL51
    
    movem.l d0-d7/a0-a6,-(a7)
    move.l #81,-(a7)
    move.w #0,-(a7)
    lea handleadress1(PC),a0

    move.l (a0),-(a7)
    jsr tios::memset
    lea 10(a7),a7
    movem.l (a7)+,d0-d7/a0-a6
    bra anfang
    
Sudoku_vorhanden:

    movem.l d0/a0-a3,-(a7)
    lea SUDOKUAktuell1(PC),a0
    move.l handleadress1(PC),a1
    lea SUDOKUAktuell2(PC),a2
    move.l handleadress2(PC),a3
    move.w #80,d0
    
sv1:
    move.b (a0)+,(a1)+
    move.b (a2)+,(a3)+
    dbra d0,sv1
    movem.l (a7)+,d0/a0-a3
    bra anfang
    
LBL51:
;Kein Sudoku vorhanden (bitte warten...)
;bei den nchsten Zeilen knnten einige sinnlos sein. 

    lea SS(PC),a0
    move.b (a0),d0
    sub.b #1,d0
    ext.w d0
    mulu #246,d0
    move.w #2,d5
omn00:
    lea SUDOKULeicht1(PC),a0
    add.l d0,a0
    cmp.b #2,(a0)
    beq oinitstartgame
    add.l #82,d0
    dbra d5,omn00
    bra omn1
    
oinitstartgame:
    move.b #0,(a0)+
    lea handleadress1(PC),a1
    move.l (a1),a1
    movem.l d0-d7/a0-a6,-(a7)
    move.l #81,-(a7) ;kopiert von sudoku in handle 1
    move.l a0,-(a7)
    move.l a1,-(a7)
    jsr tios::memcpy
    lea 12(a7),a7;
    movem.l (a7)+,d0-d7/a0-a6
    bra anfang
        
omn1:                
    jsr flib::zap_screen
    movem.l d0-d7/a0-a6,-(a7)
    move.w #4,-(a7) ;4=Schwarz auf Wei
    move.w #0,-(a7) ;y
    move.w #0,-(a7) ;x 
    lea textadresse(PC),a0
    move.l (a0),-(a7)
    move.w #5,-(a7) ; 5= "Bitte warten..."
    bsr Schreibe
    lea 12(a7),a7
    movem.l (a7)+,d0-d7/a0-a6
    move.l a7,sa71
    bsr mn

mn0:
    move.l (a7)+,a3
    tst.w d0
    bne taste_wurde_gedrckt
    lea SS(PC),a0
    move.b (a0),d0
    sub.b #1,d0
    ext.w d0
    mulu #246,d0
    move.w #2,d5
mn00:
    lea SUDOKULeicht1(PC),a0
    add.l d0,a0
    cmp.b #2,(a0)
    beq initstartgame
    add.l #82,d0
    dbra d5,mn00
    bra mn1
    
initstartgame:
    move.b #0,(a0)+
    lea handleadress1(PC),a1
    move.l (a1),a1
    movem.l d0-d7/a0-a6,-(a7)
    move.l #81,-(a7) ;kopiert von sudoku in "handle 1"
    move.l a0,-(a7)
    move.l a1,-(a7)
    jsr tios::memcpy
    lea 12(a7),a7;
    movem.l (a7)+,d0-d7/a0-a6
    bra anfang
mn1:   
   jsr (a3)
    bra mn0

taste_wurde_gedrckt    
;Start des Sudoku Erzeugers
    cmp.w #264,d0
    beq ende
    bra mn1
    
    include "erzeuger.inc"

anfang:
;Der Bildschirm wird gezeichnet.
    move.w #80,d5
    move.l handleadress1(PC),a1
    lea 81(a1),a1
    move.w #8,d1
    jsr flib::zap_screen
    
f1:
    move.w #8,d2
    
f2:
 
    move.b -(a1),d0
    movem.l d3-d4,-(a7)
    bsr zeige
    bsr rechteck
    movem.l (a7)+,d3-d4
    dbra d2,f2
    dbra d1,f1

   move.w #11,d3
   lea tab(PC),a0
            
f3:                                                   
    move.b #9,d0
    move.b #119,d1
    move.b (a0)+,d2
    bsr HorizLinie
    bsr VertLinie                 
    dbra d3,f3
    move.w #1,d3
    
f4:               
    move.b #7,d0
    move.b #121,d1
    move.b (a0)+,d2
    bsr HorizLinie
    bsr VertLinie                 
    dbra d3,f4                
    movem.l d0-d7/a0-a6,-(a7)
        
    lea SUDOKUIndex(PC),a1
    cmp.b #1,(a1)
    beq f5
    
    move.l handleadress1(PC),a1
    move.l handleadress2(PC),a5    
    move.l #81,-(a7) ;kopiert von handle1 in handle2
    move.l a1,-(a7)
    move.l a5,-(a7)
    jsr tios::memcpy
    lea 12(a7),a7
    
f5:
    move.l handleadress2(PC),a1
    lea 81(a1),a1
    move.w #8,d1
       
f5b:
    move.w #8,d2
    
f5c:
    move.b -(a1),d0
    movem.l d3-d4,-(a7)
    bsr zeige
    movem.l (a7)+,d3-d4
    dbra d2,f5c
    dbra d1,f5b

    lea SUDOKUIndex(PC),a0
    clr.b (a0)
    
    bsr tester
    Schrift_gro
    movem.l (a7)+,d0-d7/a0-a6
    clr.b d1
    clr.b d2
    bsr feld

beginn:
;Beginn der Hauptschleife
    bsr init_protokoll
    
    bsr init_idling
    bra amn2
    
amn1:   
    bsr idling
    
amn2:
;Richtungspfeile werden getestet
    bsr feld
    cmp.w #344,d0
    bne b1
    cmp.b #8,d1
    bne b0a
    move.b #-1,d1
    
b0a:
    add.b #1,d1
    
b1:
    cmp.w #338,d0
    bne b2
    tst.b d1
    bne b1a
    move.b #9,d1
b1a:
    sub.b #1,d1
b2:
    cmp.w #340,d0
    bne b3
    cmp.b #8,d2
    bne b2a
    move.b #-1,d2
b2a:
    add.b #1,d2
b3:
    cmp.w #337,d0
    bne b4
    tst.b d2
    bne b3a
    move.b #9,d2
    
b3a:
    sub.b #1,d2
    
b4:  
    cmp.w #47,d0
    bls b5
    cmp.w #57,d0
    bhi b5
;Eine Zahlentaste wurde gedrckt. Die Eingabe
;wird geschrieben, geprft und in den Verlauf
;geschrieben    
    move.b d1,d3
    ext.w d3
    ext.l d3
    mulu #9,d3
    ext.w d2
    ext.l d2
    add.l d2,d3
    move.l handleadress1(PC),a1
    add.l d3,a1
    move.l handleadress2(PC),a5
    add.l d3,a5
    tst.b (a1)
    bne b5
    move.w d0,d5
    sub.w #48,d5
    move.b (a5),d7
    move.b d5,(a5)
    exg d0,d5
    bsr zeige
    bsr tester

    movem.l d0-d7/a0-a6,-(a7)
    move.b d7,d1
    move.b d3,d0
    move.b (a5),d2
    bsr speichern
    
    movem.l (a7)+,d0-d7/a0-a6
    exg d0,d5

b5:
    cmp.w #264,d0
    bne b7
;ESC-Taste wurde gedrckt. Spielstand wird
;gespeichert und Programm beendet.
    lea SUDOKUIndex(PC),a0
    move.b #1,(a0)
    lea SUDOKUAktuell1(PC),a0
    move.l handleadress1(PC),a1
    lea SUDOKUAktuell2(PC),a2
    move.l handleadress2(PC),a3
    move.w #80,d0
    
b51:
    move.b (a1)+,(a0)+
    move.b (a3)+,(a2)+
    dbra d0,b51
    
b6:
    bra ende

b7:
    cmp.w #4360,d0
;2nd+ESC
    beq b6

;Feld lschen
    cmp.w #32,d0;" "
    beq bx
    cmp.w #263,d0;Clear
    beq bx
    cmp.w #267,d0;<-
    beq bx
    cmp.w #257,d0;???
    beq bx
    bra b8
    
bx:
    move.w #48,d0
    bra b4
    
b8:
    cmp.w #268,d0 ;F1 Lst das Sudoku
    bne b9
    
    move.l d0,-(a7)
    loesen2 #4,handleadress2(PC)
    clr.b (testflag)
    move.l (a7)+,d0
    
    movem.l d1-d2/d5/a1,-(a7)
    move.w #80,d5
    move.l handleadress2(PC),a1
    lea 81(a1),a1
    move.w #8,d1
    
b81:
    move.w #8,d2
    
b82:
    move.b -(a1),d0
    movem.l d3-d4,-(a7)
    bsr zeige
    movem.l (a7)+,d3-d4
    dbra d2,b82
    dbra d1,b81
    bsr init_protokoll
    movem.l (a7)+,d1-d2/d5/a1      
    bsr tester
    
b9:
    cmp.w #269,d0;F2: Neustart
    bne b10
    
    movem.l d0-d2/d5/a1/a2,-(a7)
    move.w #80,d5
    move.l handleadress1(PC),a1
    move.l handleadress2(PC),a2
    
b91:
    move.b (a1)+,(a2)+
    dbra d5,b91
    move.l handleadress1(PC),a1
    move.w #8,d1
    clr.l d0
    
b93:
    move.w #8,d2
    
b94:
    move.w d1,d3
    mulu #9,d3
    add.w d2,d3
    move.b 0(a1,d3.w),d0
    bsr zeige
    dbra d2,b94
    dbra d1,b93
    movem.l (a7)+,d0-d2/d5/a1/a2
    bsr init_protokoll
    bsr tester
    
b10:
    cmp.w #270,d0 ;F3: Rckgngig
    bne b11
    bsr zurck
    bsr tester

b11:
    cmp.w #271,d0; F4: Wiederherstellen
    bne b12
    bsr vorwrts
    bsr tester

b12:
    
    bsr feld
    bra amn1                                  

;----------
    include "neu.inc"
;---------
rechteck:
;Markiert Felder schon vorhandener Zahlen
    tst.b d0
    beq re
    movem.l d0-d2,-(a7)
    bsr aufb
    add.w #10,d1
    add.w #10,d2
    move.w d1,d3
    move.w d2,d4
    bsr r1
    add.w #10,d1
    bsr r1
    add.w #10,d2
    bsr r1
    sub.w #10,d1
    bsr r1
    movem.l (a7)+,d0-d2
    rts

r1:
    move.w d1,-(a7)
    move.w d2,-(a7)
    jsr flib::pixel_on
    add.l #4,a7
re:
    rts
;--------
zeige:
;zeigt eine Zahl (d0.b) zwischen 0 und 9,
;in Feld (x=d2.w,y=d1.w) an                        
    movem.l d0-d7/a0,-(a7)      
    bsr aufb
    add.w #11,d1
    add.w #11,d2
    tst.b d0
    beq z2
    add.b #48,d0
z0:
    lea zeiger(PC),a0
    move.b d0,(a0)
    movem.l d0-d7/a0-a6,-(a7)
    move.w #4,-(a7)
    move.l a0,-(a7)
    move.w d1,-(a7)
    move.w d2,-(a7)
    jsr tios::DrawStrXY
    lea 10(a7),a7
    movem.l (a7)+,d0-d7/a0-a6
z1:
    movem.l (a7)+,d0-d7/a0
    rts
z2:
    move.b #32,d0
    bra z0
    

HorizLinie:
;macht eine horizontale Linie von d0.b
;zu d1.b auf d2.b
    movem.l d0-d5/a0,-(a7)   
    ext.w d2
    mulu.w #30,d2
    ext.l d2
    move.l d2,a0
    add.l #LCD_MEM,a0
    move.b d0,d3
    and.b #$07,d3;  d3=Modulo (Rest) von d0/8
    move.b d0,d4
    lsr.b #3,d4; d4=d0/8
    ext.w d4
    ext.l d4
    add.l d4,a0
    sub.b d0,d1 ; d1.b = Lnge der Linie
    move.b #7,d4
    sub.b d3,d4
    sub.b d1,d4
    bhi zeichne_einzeln
    beq zeichne_einzeln

    move.b #$FF,d2
    lsr.b d3,d2
;    move.b (a0),d5  
;    or.b d2,d5      
;    move.b d5,(a0)+
    or.b d2,(a0)+;;
    add.b d3,d1
    sub.b #8,d1
    move.b #$FF,d2
h1:    
    cmp.b #7,d1
    bls h2
;    move.b (a0),d5  ;r
;    or.b d2,d5      ;r
;    move.b d5,(a0)+ ;d2,
    or.b d2,(a0)+;;
    sub.b #8,d1
    bra h1
h2:
    tst.b d1
    beq h3
    move.b #8,d4
    sub.b d1,d4
    lsl.b d4,d2
;    move.b (a0),d5  ;r
;    or.b d2,d5      ;r
;    move.b d5,(a0) ;d2,
    or.b d2,(a0)+;;
    bra h3
zeichne_einzeln:
    move.b #$FF,d2
    move.b d2,d0
    lsr.b d3,d2
    lsl.b d4,d0
    and.b d2,d0
;    move.b (a0),d5  ;r
;    or.b d0,d5      ;r
;    move.b d5,(a0)+ ;d2,
    or.b d0,(a0)+
    
h3:
    movem.l (a7)+,d0-d5/a0   
    rts
    
;-----------------

VertLinie:             
;macht eine vertikale Linie von d0.b zu d1.b auf d2.b
    movem.l d0-d2/a0,-(a7)   
    sub.b d0,d1
    ext.w d0
    ext.l d0
    mulu #30,d0
    move.l d0,a0
    move.b d2,d0
    lsr.b #3,d2
    and.b #$07,d0
    ext.w d2
    ext.l d2
    add.l d2,a0
    move.b #7,d2
    sub.b d0,d2
    move.b d2,d0
    add.l #LCD_MEM,a0

    and.w #$00FF,d1
v1:
    move.b (a0),d2
    bset.b d0,d2
    move.b d2,(a0)
    lea 30(a0),a0
    dbra d1,v1
    movem.l (a7)+,d0-d2/a0   
    rts
        
;------------------------------
Eingabe:
;Gibt den Eingabebildschirm aus
    movem.l d0-d7/a0-a6,-(a7)
    jsr flib::zap_screen
    move.l #LCD_MEM,a0
    add.l #306,a0
    lea Bild(PC),a1
    move.w #24,d0
EB1:
    move.l (a1)+,(a0)+
    move.l (a1)+,(a0)+
    move.l (a1)+,(a0)+
    move.l (a1)+,(a0)+
    move.w (a1)+,(a0)+
    lea 12(a0),a0
    dbra d0,EB1
    
    Schrift_klein

    move.w #4,-(a7)
    move.w #40,-(a7) ;y
    move.w #58,-(a7) ;x 
    lea textadresse(PC),a0
    move.l (a0),-(a7)
    move.w #11,-(a7);fargo-version
    bsr Schreibe
    
    Schrift_gro

    move.w #73,6(a7)
    move.w #55,8(a7) ;y
    move.w #6,(a7);einfach
    bsr Schreibe
    
    move.w #67,8(a7) ;y orginal -5
    move.w #7,(a7);normal
    bsr Schreibe

    move.w #79,8(a7) ;y
    move.w #8,(a7);schwierig
    bsr Schreibe

    move.w #91,8(a7) ;y
    move.w #9,(a7);auflsen
    bsr Schreibe

    move.w #103,8(a7) ;y
    move.w #10,(a7);hilfe
    bsr Schreibe
    lea 12(a7),a7

    movem.l (a7)+,d0-d7/a0-a6

    bsr init_idling
    bra emn2
    
emn1:   
    bsr idling
    
emn2:

    cmp.w #268,d0
    beq start_einfach
    cmp.w #269,d0
    beq start_normal
    cmp.w #270,d0
    beq start_schwierig
    cmp.w #271,d0
    beq start_aufloesen
    cmp.w #272,d0
    beq start_hilfe
    cmp.w #264,d0
    beq start_ende
    cmp.w #4360,d0
    beq start_ende
    bra emn1
    
start_einfach:
    lea SS(PC),a0
    move.b #1,(a0)
    rts
    
start_normal:
    lea SS(PC),a0
    move.b #2,(a0)
    rts
           
start_schwierig:
    lea SS(PC),a0
    move.b #3,(a0)
    rts
    
start_aufloesen:
    lea SS(PC),a0
    move.b #4,(a0)
    rts

    
start_hilfe:
    movem.l d0-d7/a0-a6,-(a7)
    Schrift_normal
    jsr flib::zap_screen
    move.w #4,-(a7)
    move.w #0,-(a7)
    move.w #0,-(a7)

    pea text(PC)
    move.w #0,-(a7)
    bsr Schreibe
    lea 12(a7),a7
    
    
versuch:

    move.w #16,d0
    move.w #11,d1
    
versuch1:
    move.w d1,d2
    add.w d1,d2
    movem.l d0-d2,-(a7)
    move.w #4,-(a7)

    lea textadresse(PC),a0
    move.l (a0),a0
    move.l a0,a1
    ext.l d2
    add.l d2,a0
    move.w (a0),d2
    ext.l d2
    add.l d2,a1
    move.l a1,-(a7)
    move.w d0,-(a7) ;y
    move.w #0,-(a7) ;x
    jsr tios::DrawStrXY
    lea 10(a7),a7
    movem.l (a7)+,d0-d2
    add.w #8,d0
    add.w #1,d1
    cmp.w #24,d1
    bls versuch1
    
    movem.l (a7)+,d0-d7/a0-a6    
    
    bsr init_idling
   
    bra Eingabe
     
     
      
       
         
start_ende    
    add.l #4,a7
    bra ende
;RANDOM
 
rand:
    move.l seed(PC),d0
    move.l #1947481647,d1
    move.l d0,d2
    swap d2
    move.l d1,d3
    swap d3
    mulu d1,d2
    mulu d0,d3
    add.l d2,d3
    mulu d0,d1
    ext.l d3
    swap d3
    add.l d1,d3
    add.l #7649,d3
    move.l d3,seed
    move.l #9,d0
    lsr.l d0,d3
    move.w d3,d0
    rts
 
 
random:
    movem.l d1-d7/a0-a6,-(a7)
    move.w d0,d7
    bsr rand
    divu d7,d0
    swap d0
    and.l #$0000FFFF,d0
    movem.l (a7)+,d1-d7/a0-a6
    rts
;---------------------------------------------

feld: 
;Invertiert das Feld
;input d1-yfeld ; d2-xfeld


    movem.l d1-d4/a0,-(a7)
    bsr aufb
    add.w #9,d1
    add.w #9,d2
    move.l #$FFF80000,d3
    move.b d2,d4
    lsr.b #4,d2
    lsl.b #1,d2
    and.l #$0F,d4
    cmp.b #8,d4
    bls fe1
    lsr.l #8,d3
    sub.l #8,d4
fe1:
    lsr.l d4,d3
    mulu #30,d1
    add.l d1,d2
    move.l #LCD_MEM,a0
    add.l d2,a0
    move.l #12,d2
fe2:
    move.l (a0),d1
    eor.l d3,d1
    move.l d1,(a0)
    lea 30(a0),a0
    dbra d2,fe2
    movem.l (a7)+,d1-d4/a0
    rts   
    
;-------------------------
aufb:
;gibt die Bildschirm-Position der Felder  
;x-d1 und y-d2, in d1,d2, zurck
    ext.w d1
    move.w d1,d4
    ext.l d4
    divu #3,d4
    mulu #12,d1
    add.w d4,d1

    ext.w d2
    move.w d2,d4
    ext.l d4
    divu #3,d4
    mulu #12,d2
    add.w d4,d2
    rts
;-------------------------------------------------------------------------------
gelst:
;Vielleicht ein netterer Schlussbildschirm ;-) 

    Schrift_normal

    move.w #4,-(a7)
    move.w #9,-(a7) ;y
    move.w #125,-(a7) ;x 
    lea textadresse(PC),a0
    move.l (a0),-(a7)
    move.w #4,-(a7)
    bsr Schreibe
    lea 12(a7),a7
    
    bsr init_idling

    rts

;    include "time.h"
;Ein Timer wre super
    
;******************** Program Variables ***********************
    even

handleadress1       dc.l handle1
handleadress2       dc.l handle2
handleadress3       dc.l handle3
handleadress4       dc.l handle4
handleloeseadress   dc.l handleloese
handlestackadress   dc.l handlestack2+256
handleadress5       dc.l handle5
stvo                dc.w 0,4,4
sa71                dc.l 0
sa72                dc.l 0
sa6                 dc.l 0
seed				dc.l 0
summenadr           dc.l summen
gesp_Schritte       dc.b 0
Schritte            dc.b 0
    include "bild.inc"
ungel               dc.b 0
stat                dc.b 0
tab                 dc.b 09,21,33,45,46,58,70,82,83,95,107,119,7,121
    include Sudokus.inc
SUDOKUIndex         dc.b 0
SUDOKUAktuell1      dcb.b 81,0
SUDOKUAktuell2      dcb.b 81,0
zeiger   dcb.b 2,0
SS       dc.b 1;Schwierigkeitsstufe
SS2         dc.b 1
    even
textadresse:    dc.l 0
text:      dc.w   _comment-text  ;0
          dc.w    eingab-text       ;1
          dc.w    Fehler-text       ;2
          dc.w    kein_Fehler-text  ;3
          dc.w    geloest-text      ;4
          dc.w    erstellen-text    ;5
          dc.w    einfach-text      ;6
          dc.w    normal-text       ;7
          dc.w    schwierig-text    ;8
          dc.w    aufloesen-text    ;9
          dc.w    hilfe-text        ;10
          dc.w    zeile1-text       ;11
          dc.w    null-text         ;12
          dc.w    zeile2-text       ;13
          dc.w    zeile3-text       ;14
          dc.w    zeile4-text       ;15
          dc.w    zeile5-text       ;16
          dc.w    zeile6-text       ;17
          dc.w    null-text         ;18
          dc.w    zeile7-text       ;19
          dc.w    zeile8-text       ;20
          dc.w    zeile9-text       ;21
          dc.w    zeile10-text      ;22
          dc.w    null-text       ;23
          dc.w    zeile11-text      ;24
          
          dc.w    zeile13-text      ;25         
          dc.w    zeile14-text      ;26        
          dc.w    zeile15-text      ;27       
          dc.w    zeile16-text      ;28
          dc.w    zeile16b-text     ;29          
          dc.w    zeile17-text      ;30
          dc.w    zeile17b-text     ;31          
          dc.w    zeile18-text      ;32

;Willkommen  dc.b "Zahlenrtsel v.1.1",0
eingab   dc.b "Schwierigkeitsstufe:",0


Fehler      dc.b "Status: unmglich",0
kein_Fehler dc.b "Status: mglich  ",0
geloest     dc.b "Status: gelst   ",0
erstellen   dc.b "bitte warten...",0
einfach     dc.b "F1 Einfach",0
normal      dc.b "F2 Normal",0
schwierig   dc.b "F3 Schwierig",0
aufloesen   dc.b "F4 Auflsen",0
hilfe       dc.b "F5 Hilfe",0
zeile1      dc.b "Copyright 2006 by Simon Weitzhofer",0

zeile2      dc.b "Dieses Programm ist fr den nicht-",0
zeile3      dc.b "kommerziellen Gebrauch bestimmt und",0
zeile4      dc.b "kann frei verwendet, kopiert und ver-",0
zeile5      dc.b "ndert werden. Eine Haftung fr Schden",0
zeile6      dc.b "jedweder Art ist ausgeschlossen.",0

zeile7      dc.b "Bei einem Sudoku mssen, in jeder",0
zeile8      dc.b "Spalte, in jeder Zeile und in jedem",0 
zeile9      dc.b "Feld, die Zahlen 1-9 genau einmal",0 
zeile10      dc.b "vorkommen.",0
zeile11     dc.b "Weiter mit beliebiger Taste.",0
;zeile12     
zeile13     dc.b "F1   Auflsen",0
zeile14     dc.b "F2   Neustart",0
zeile15     dc.b "F3   Rckgngig",0
zeile16     dc.b "F4   Wiederher-",0
zeile16b    dc.b "     stellen",0
zeile17     dc.b "Esc  Speichern &",0
zeile17b    dc.b "     beenden",0
zeile18     dc.b "Quit Beenden",0
null      dc.b 0

testflag dc.b 0
;Speicher    dc.b "Zu wenig Speicher frei!",0
;Wiedersehen dc.b "Auf Wiedersehen",0

_comment    dc.b    "Zahlenrtsel Version 1.2",0

    bss
summen              dcb.w 512
    even
handleloese         dcb.b 162
    even
handlestack2        dcb.b 256
    even
handle5             dcb.b 324
handle1             dcb.b 81
handle2             dcb.b 81
handle3             dcb.b 81
handle4             dcb.b 81

    
;********************** End of Program ************************3d26
    end
